# 1 "src/arch/riscv/mcall.c"
# 1 "<built-in>" 1
# 1 "<built-in>" 3
# 381 "<built-in>" 3
# 1 "<command line>" 1
# 1 "<built-in>" 2
# 1 "./src/include/kconfig.h" 1



# 1 "/cb-build/coreboot_scanbuild.0/EMULATION_SPIKE_RISCV/config.h" 1
# 5 "./src/include/kconfig.h" 2
# 2 "<built-in>" 2
# 1 "./src/include/rules.h" 1
# 3 "<built-in>" 2
# 1 "./src/commonlib/bsd/include/commonlib/bsd/compiler.h" 1
# 4 "<built-in>" 2
# 1 "src/arch/riscv/mcall.c" 2


# 1 "src/arch/riscv/include/mcall.h" 1
# 21 "src/arch/riscv/include/mcall.h"
# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 22 "src/arch/riscv/include/mcall.h" 2
# 1 "src/arch/riscv/include/arch/smp/atomic.h" 1





# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 7 "src/arch/riscv/include/arch/smp/atomic.h" 2

typedef struct { volatile int counter; } atomic_t;
# 24 "src/arch/riscv/include/arch/smp/atomic.h"
static inline int atomic_add(atomic_t *v, int inc)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter += inc;
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_swap(atomic_t *v, int swp)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter = swp;
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_cas(atomic_t *v, int cmp, int swp)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter = (res == cmp ? swp : res);
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_inc(atomic_t *v)
{
 return atomic_add(v, 1);
}

static inline int atomic_dec(atomic_t *v)
{
 return atomic_add(v, -1);
}
# 23 "src/arch/riscv/include/mcall.h" 2
# 1 "src/include/stdint.h" 1






typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef signed short int16_t;
typedef unsigned short uint16_t;

typedef signed int int32_t;
typedef unsigned int uint32_t;

typedef signed long long int64_t;
typedef unsigned long long uint64_t;


typedef signed long intptr_t;
typedef unsigned long uintptr_t;


_Static_assert(sizeof(int8_t) == 1, "Size of int8_t is incorrect");
_Static_assert(sizeof(uint8_t) == 1, "Size of uint8_t is incorrect");

_Static_assert(sizeof(int16_t) == 2, "Size of int16_t is incorrect");
_Static_assert(sizeof(uint16_t) == 2, "Size of uint16_t is incorrect");

_Static_assert(sizeof(int32_t) == 4, "Size of int32_t is incorrect");
_Static_assert(sizeof(uint32_t) == 4, "Size of uint32_t is incorrect");

_Static_assert(sizeof(int64_t) == 8, "Size of int64_t is incorrect");
_Static_assert(sizeof(uint64_t) == 8, "Size of uint64_t is incorrect");

_Static_assert(sizeof(intptr_t) == sizeof(void *), "Size of intptr_t is incorrect");
_Static_assert(sizeof(uintptr_t) == sizeof(void *), "Size of uintptr_t is incorrect");


typedef int64_t intmax_t;
typedef uint64_t uintmax_t;


typedef int8_t s8;
typedef uint8_t u8;

typedef int16_t s16;
typedef uint16_t u16;

typedef int32_t s32;
typedef uint32_t u32;

typedef int64_t s64;
typedef uint64_t u64;
# 24 "src/arch/riscv/include/mcall.h" 2

struct sbi_device_message {
 unsigned long dev;
 unsigned long cmd;
 unsigned long data;
 unsigned long sbi_private_data;
};

struct blocker {
 void *arg;
 void (*fn)(void *arg);
 atomic_t sync_a;
 atomic_t sync_b;
};

struct hls {
 struct sbi_device_message *device_request_queue_head;
 unsigned long device_request_queue_size;
 struct sbi_device_message *device_response_queue_head;
 struct sbi_device_message *device_response_queue_tail;

 int hart_id;
 int ipi_pending;
 uint64_t *timecmp;
 uint64_t *time;
 void *fdt;
 struct blocker entry;
};

_Static_assert(
 sizeof(struct hls) == 88,
 "HLS_SIZE must equal to sizeof(struct hls)");

register uintptr_t current_stack_pointer asm("sp");
# 69 "src/arch/riscv/include/mcall.h"
void hls_init(uint32_t hart_id, void *fdt);


void mtime_init(void);
# 81 "src/arch/riscv/include/mcall.h"
void set_msip(int hartid, int val);
# 4 "src/arch/riscv/mcall.c" 2
# 1 "src/include/string.h" 1





# 1 "src/include/stdarg.h" 1
# 11 "src/include/stdarg.h"
# 1 "src/include/stddef.h" 1





# 1 "src/commonlib/include/commonlib/helpers.h" 1
# 10 "src/commonlib/include/commonlib/helpers.h"
# 1 "src/commonlib/bsd/include/commonlib/bsd/helpers.h" 1







# 1 "src/include/stddef.h" 1
# 9 "src/commonlib/bsd/include/commonlib/bsd/helpers.h" 2
# 11 "src/commonlib/include/commonlib/helpers.h" 2
# 7 "src/include/stddef.h" 2

typedef long int ptrdiff_t;
typedef long unsigned int size_t;






typedef long signed int ssize_t;


typedef int wchar_t;
typedef unsigned int wint_t;
# 42 "src/include/stddef.h"
extern char zeroptr[];
# 12 "src/include/stdarg.h" 2




typedef __builtin_va_list va_list;

int vsnprintf(char *buf, size_t size, const char *fmt, va_list args);
# 7 "src/include/string.h" 2

# 1 "src/include/stdio.h" 1
# 13 "src/include/stdio.h"
int snprintf(char *buf, size_t size, const char *fmt, ...);
# 9 "src/include/string.h" 2

void *memcpy(void *dest, const void *src, size_t n);
void *memmove(void *dest, const void *src, size_t n);
void *memset(void *s, int c, size_t n);
int memcmp(const void *s1, const void *s2, size_t n);
void *memchr(const void *s, int c, size_t n);
char *strdup(const char *s);
char *strconcat(const char *s1, const char *s2);
size_t strnlen(const char *src, size_t max);
size_t strlen(const char *src);
char *strchr(const char *s, int c);
char *strncpy(char *to, const char *from, int count);
char *strcpy(char *dst, const char *src);
int strcmp(const char *s1, const char *s2);
int strncmp(const char *s1, const char *s2, int maxlen);
int strspn(const char *str, const char *spn);
int strcspn(const char *str, const char *spn);
char *strstr(const char *haystack, const char *needle);
char *strtok_r(char *str, const char *delim, char **ptr);
char *strtok(char *str, const char *delim);
long atol(const char *str);
# 39 "src/include/string.h"
char *strrchr(const char *s, int c);






unsigned int skip_atoi(char **s);
# 5 "src/arch/riscv/mcall.c" 2
# 1 "src/arch/riscv/include/vm.h" 1







# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 9 "src/arch/riscv/include/vm.h" 2




void mstatus_init(void);
# 60 "src/arch/riscv/include/vm.h"
static inline uint8_t mprv_read_u8(uint8_t *p); static inline uint8_t mprv_read_u8(uint8_t *p) { size_t mprv = 0x00020000; uint8_t value; asm ( "csrs		mstatus, %1\n" "lbu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint16_t mprv_read_u16(uint16_t *p); static inline uint16_t mprv_read_u16(uint16_t *p) { size_t mprv = 0x00020000; uint16_t value; asm ( "csrs		mstatus, %1\n" "lhu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint32_t mprv_read_u32(uint32_t *p); static inline uint32_t mprv_read_u32(uint32_t *p) { size_t mprv = 0x00020000; uint32_t value; asm ( "csrs		mstatus, %1\n" "lwu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint64_t mprv_read_u64(uint64_t *p); static inline uint64_t mprv_read_u64(uint64_t *p) { size_t mprv = 0x00020000; uint64_t value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline long mprv_read_long(long *p); static inline long mprv_read_long(long *p) { size_t mprv = 0x00020000; long value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline unsigned long mprv_read_ulong(unsigned long *p); static inline unsigned long mprv_read_ulong(unsigned long *p) { size_t mprv = 0x00020000; unsigned long value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint8_t mprv_read_mxr_u8(uint8_t *p); static inline uint8_t mprv_read_mxr_u8(uint8_t *p) { size_t mprv = 0x00020000 | 0x00080000; uint8_t value; asm ( "csrs		mstatus, %1\n" "lbu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint16_t mprv_read_mxr_u16(uint16_t *p); static inline uint16_t mprv_read_mxr_u16(uint16_t *p) { size_t mprv = 0x00020000 | 0x00080000; uint16_t value; asm ( "csrs		mstatus, %1\n" "lhu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint32_t mprv_read_mxr_u32(uint32_t *p); static inline uint32_t mprv_read_mxr_u32(uint32_t *p) { size_t mprv = 0x00020000 | 0x00080000; uint32_t value; asm ( "csrs		mstatus, %1\n" "lwu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint64_t mprv_read_mxr_u64(uint64_t *p); static inline uint64_t mprv_read_mxr_u64(uint64_t *p) { size_t mprv = 0x00020000 | 0x00080000; uint64_t value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline long mprv_read_mxr_long(long *p); static inline long mprv_read_mxr_long(long *p) { size_t mprv = 0x00020000 | 0x00080000; long value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline unsigned long mprv_read_mxr_ulong(unsigned long *p); static inline unsigned long mprv_read_mxr_ulong(unsigned long *p) { size_t mprv = 0x00020000 | 0x00080000; unsigned long value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline void mprv_write_u8(uint8_t *p, uint8_t value); static inline void mprv_write_u8(uint8_t *p, uint8_t value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sb" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_u16(uint16_t *p, uint16_t value); static inline void mprv_write_u16(uint16_t *p, uint16_t value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sh" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_u32(uint32_t *p, uint32_t value); static inline void mprv_write_u32(uint32_t *p, uint32_t value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sw" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_u64(uint64_t *p, uint64_t value); static inline void mprv_write_u64(uint64_t *p, uint64_t value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sd" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_long(long *p, long value); static inline void mprv_write_long(long *p, long value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sd" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_ulong(unsigned long *p, unsigned long value); static inline void mprv_write_ulong(unsigned long *p, unsigned long value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sd" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }





 static inline uintptr_t mprv_read_uintptr_t(uintptr_t *p); static inline uintptr_t mprv_read_uintptr_t(uintptr_t *p) { size_t mprv = 0x00020000; uintptr_t value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
 static inline uintptr_t mprv_write_uintptr_t(uintptr_t *p); static inline uintptr_t mprv_write_uintptr_t(uintptr_t *p) { size_t mprv = 0x00020000; uintptr_t value; asm ( "csrs		mstatus, %1\n" "sd" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
# 6 "src/arch/riscv/mcall.c" 2

void hls_init(uint32_t hart_id, void *fdt)
{
 memset(((struct hls *)(({ (void *)((current_stack_pointer + (1 << 12)) & -(1 << 12)); }) - 88)), 0, sizeof(*((struct hls *)(({ (void *)((current_stack_pointer + (1 << 12)) & -(1 << 12)); }) - 88))));
 ((struct hls *)(({ (void *)((current_stack_pointer + (1 << 12)) & -(1 << 12)); }) - 88))->fdt = fdt;
 ((struct hls *)(({ (void *)((current_stack_pointer + (1 << 12)) & -(1 << 12)); }) - 88))->hart_id = hart_id;

 mtime_init();
}
